%global         commit 7d0c44309714e5cef6a40f0f9a085d860b69ce0f
%global         shortcommit %(c=%{commit}; echo ${c:0:7})
%global         commands account hardware journald logicalfile networking
%global         commands %{commands} powermanagement service software storage
%global         commands %{commands} system
%global         tools_version 0.9.1

Name:           openlmi-scripts
Version:        0.3.0
Release:        1%{?dist}
Summary:        Client-side python modules and command line utilities

License:        GPLv2+
URL:            http://fedorahosted.org/openlmi
Source0:        https://github.com/openlmi/%{name}/archive/%{commit}/%{name}-%{version}-%{shortcommit}.tar.gz
# Due to a move of LMI Meta-command from openlmi-scripts git to openlmi-tools
# and its absence of it in RHEL's openlmi-tools package, it needs to be pulled
# from upstream tarball of openlmi-tools.
Source1:        http://fedorahosted.org/released/openlmi-tools/openlmi-tools-%{tools_version}.tar.gz
BuildArch:      noarch
Patch0:         openlmi-tools-0.9.1-setup.patch
Patch1:         openlmi-scripts-0.3.0-requirements.patch
Patch2:         openlmi-tools-0.9.1-doc.patch
Patch3:         openlmi-scripts-0.3.0-doc_build.patch
Patch4:         openlmi-tools-0.9.1-python_egg_name.patch

BuildRequires:  python2-devel
# For documentation
BuildRequires:  python-docopt
BuildRequires:  python-sphinx
BuildRequires:  python-sphinx-theme-openlmi
BuildRequires:  openlmi-tools >= 0.9
BuildRequires:  python-IPy
BuildRequires:  ImageMagick
BuildRequires:  pyparsing
Requires:       python2
Requires:       openlmi-python-base >= 0.3.0
Requires:       python-docopt >= 0.6.1
Requires:       openlmi-tools >= 0.9
Requires:       pyparsing

%description
Client-side python modules and command line utilities for OpenLMI providers.

%package        doc
Summary:        OpenLMI scripts documentation
Group:          Documentation

%description    doc
This package contains the documents for OpenLMI Scripts.

%package        account
Summary:        Client scripts for OpenLMI Account provider
License:        BSD
Requires:       openlmi-tools >= 0.9

%description    account
This packages contains client side python library for OpenLMI Account
provider and command line wrapper.

%package        hardware
Summary:        Client scripts for OpenLMI Hardware provider
License:        BSD
Requires:       openlmi-tools >= 0.9

%description    hardware
This packages contains client side python library for OpenLMI Hardware
provider and command line wrapper.

%package        journald
Summary:        Client scripts for OpenLMI Journald provider
License:        BSD
Requires:       openlmi-tools >= 0.9

%description    journald
This packages contains client side python library for OpenLMI Journald
provider and command line wrapper.

%package        logicalfile
Summary:        Client scripts for OpenLMI Logical File provider
License:        BSD
Requires:       openlmi-tools >= 0.9

%description    logicalfile
This packages contains client side python library for OpenLMI Logical File
provider and command line wrapper.

%package        networking
Summary:        Client scripts for OpenLMI Networking provider
License:        BSD
Requires:       openlmi-tools >= 0.9
Requires:       python-IPy

%description    networking
This packages contains client side python library for OpenLMI Networking
provider and command line wrapper.

%package        powermanagement
Summary:        Client scripts for OpenLMI Power provider
License:        BSD
Requires:       openlmi-tools >= 0.9

%description    powermanagement
This packages contains client side python library for OpenLMI PowerManagement
provider and command line wrapper.

%package        service
Summary:        Client scripts for OpenLMI Service provider
License:        BSD
Requires:       openlmi-tools >= 0.9

%description    service
This packages contains client side python library for OpenLMI Service
provider and command line wrapper.

%package        software
Summary:        Client scripts for OpenLMI Software provider
License:        BSD
Requires:       openlmi-tools >= 0.9

%description    software
This packages contains client side python library for OpenLMI Software
provider and command line wrapper.

%package        storage
Summary:        Client scripts for OpenLMI Storage provider
License:        BSD
Requires:       openlmi-tools >= 0.9

%description    storage
This packages contains client side python library for OpenLMI Storage
provider and command line wrapper.

%package        system
Summary:        Client scripts providing general system information
License:        BSD
Requires:       openlmi-tools >= 0.9
Requires:       %{name}-service >= %{version}-%{release}

%description    system
This package contains client side python library for few OpenLMI providers and
command line wrapper. It's aimed to provide some general information about
system.


%prep
%setup -cqn %{name} -a 1
%patch0 -p1 -b .setup
%patch1 -p1 -b .requirements
%patch2 -p1 -b .doc
%patch3 -p1 -b .doc_build
%patch4 -p1 -b .python_egg_name

%build
pushd openlmi-tools-%{tools_version}
    # build lmi meta-command
    pushd cli
        %{__python} setup.py build
    popd # cli

    # build meta-command's documentation
    pushd doc
        make html
        [ -e build/html/.buildinfo ] && rm build/html/.buildinfo
    popd # doc
popd # openlmi-tools

pushd %{name}-%{commit}
    # build scripts and their documentation
    COMMANDS="%{commands}" make setup-all
    for cmd in %{commands}; do
        pushd commands/$cmd
            %{__python} setup.py build
            cd doc
            # Since setup.py depends on openlmi-scripts (which was changed with
            # requirements patch), setuptools will try to download it from PyPI,
            # which is wrong. Let's install it manually from local openlmi-tools.
            # DEPS variable is set to a path with setup.py script that shall
            # be run before script setup.py of particular script library.
            DEPS=%{_builddir}/%{buildsubdir}/openlmi-tools-%{tools_version}/cli make html
            [ -e _build/html/.buildinfo ] && rm _build/html/.buildinfo
        popd # commands/$cmd
    done
popd # openlmi-scripts

%install
pushd openlmi-tools-%{tools_version}
    # install lmi meta-command
    pushd cli
        %{__python} setup.py install -O1 --skip-build --root %{buildroot}
        cp -p lmi/scripts/__init__.* %{buildroot}%{python_sitelib}/lmi/scripts

        # install man dir
        install -m 0755 -d %{buildroot}%{_mandir}/man1
        install -m 0644 man/lmi.1 %{buildroot}%{_mandir}/man1

        # install config file
        install -m 0755 -d %{buildroot}%{_sysconfdir}/openlmi/scripts
        install -m 0644 config/lmi.conf %{buildroot}%{_sysconfdir}/openlmi/scripts

        # bash completion
        pushd completion
            install -m 0755 -d %{buildroot}%{_sysconfdir}/bash_completion.d
            install -m 0644 lmi.bash %{buildroot}%{_sysconfdir}/bash_completion.d
            install -m 0755 -d %{buildroot}%{_libexecdir}/lmi-bash-completion
            install -m 0755 lmi-bash-completion/print_possible_commands.sh \
                    %{buildroot}%{_libexecdir}/lmi-bash-completion
            cp -pr lmi-bash-completion/commands \
                    %{buildroot}%{_libexecdir}/lmi-bash-completion
        popd # completion
    popd # cli


    # install meta-commands' documentation
    install -m 0755 -d %{buildroot}%{_docdir}/%{name}
    cp -rp doc/build/html %{buildroot}%{_docdir}/%{name}
    install -m 0644 COPYING %{buildroot}%{_docdir}/%{name}

popd # openlmi-tools

pushd %{name}-%{commit}
    # install scripts and their documentation
    for cmd in %{commands}; do
        pushd commands/$cmd
            %{__python} setup.py install -O1 --skip-build --root %{buildroot}
            install -m 0755 -d %{buildroot}%{_docdir}/%{name}-$cmd
            cp -rp doc/_build/html %{buildroot}%{_docdir}/%{name}-$cmd
            install -m 0644 README.md ../../COPYING \
                    %{buildroot}%{_docdir}/%{name}-$cmd
        popd # commands/$cmd

        # install documentation
        install -m 0755 -d %{buildroot}%{_docdir}/%{name}
        install -m 0644 README.md %{buildroot}%{_docdir}/%{name}
    done
popd # openlmi-scripts

%files
%doc %{_docdir}/%{name}/README.md
%doc %{_docdir}/%{name}/COPYING
%{_bindir}/lmi
%dir %{_sysconfdir}/openlmi/scripts
%config(noreplace) %{_sysconfdir}/openlmi/scripts/lmi.conf
%{_sysconfdir}/bash_completion.d/lmi.bash
%dir %{_libexecdir}/lmi-bash-completion
%dir %{_libexecdir}/lmi-bash-completion/commands
%{_libexecdir}/lmi-bash-completion/*.sh
%{_libexecdir}/lmi-bash-completion/commands/_help
%dir %{python_sitelib}/lmi/scripts
%{python_sitelib}/lmi/scripts/__init__.py*
%{python_sitelib}/lmi/scripts/common
%{python_sitelib}/lmi/scripts/_metacommand
%{python_sitelib}/openlmi_scripts-*
%{_mandir}/man1/lmi.1.gz

%files doc
%{_docdir}/%{name}/html

%files account
%doc %{_docdir}/%{name}-account/
%{python_sitelib}/lmi/scripts/account/
%{python_sitelib}/openlmi_scripts_account-*

%files hardware
%doc %{_docdir}/%{name}-hardware/
%{python_sitelib}/lmi/scripts/hardware/
%{python_sitelib}/openlmi_scripts_hardware-*

%files journald
%doc %{_docdir}/%{name}-journald/
%{python_sitelib}/lmi/scripts/journald/
%{python_sitelib}/openlmi_scripts_journald-*

%files logicalfile
%doc %{_docdir}/%{name}-logicalfile/
%{python_sitelib}/lmi/scripts/logicalfile/
%{python_sitelib}/openlmi_scripts_logicalfile-*

%files networking
%doc %{_docdir}/%{name}-networking/
%{python_sitelib}/lmi/scripts/networking/
%{python_sitelib}/openlmi_scripts_networking-*

%files powermanagement
%doc %{_docdir}/%{name}-powermanagement/
%{python_sitelib}/lmi/scripts/powermanagement/
%{python_sitelib}/openlmi_scripts_powermanagement-*

%files service
%doc %{_docdir}/%{name}-service/
%{python_sitelib}/lmi/scripts/service/
%{python_sitelib}/openlmi_scripts_service-*

%files software
%doc %{_docdir}/%{name}-software/
%{python_sitelib}/lmi/scripts/software/
%{python_sitelib}/openlmi_scripts_software-*

%files storage
%doc %{_docdir}/%{name}-storage/
%{python_sitelib}/lmi/scripts/storage/
%{python_sitelib}/openlmi_scripts_storage-*

%files system
%doc %{_docdir}/%{name}-system/
%{python_sitelib}/lmi/scripts/system/
%{python_sitelib}/openlmi_scripts_system-*

%changelog
* Tue Apr 29 2014 Michal Minar <miminar@redhat.com> 0.3.0-1
- Updated to new upstream version 0.3.0.
- Added openlmi-tools source due to meta-command's absence in source tarball.
- Documentation package ships just documentation for meta-command.
- Each script sub-package now contains related documentation.
- Added journald sub-package.

* Mon Mar 10 2014 Michal Minar <miminar@redhat.com> 0.2.7-8
- Fixed listing of thin volumes/groups in provides.
- Smart hostname selection when no hosts are given.
- System command improvements.
- Fixed storage error reporting.

* Wed Mar 05 2014 Michal Minar <miminar@redhat.com> 0.2.7-7
- Fixed few networking bugs.
- Fixed duplicate headers.

* Tue Mar 04 2014 Michal Minar <miminar@redhat.com> 0.2.7-6
- Fixed search command of software scripts.

* Wed Feb 26 2014 Michal Minar <miminar@redhat.com> 0.2.7-5
- Fixed error handling in service scripts.
- Updated documentation for built-ins commands.
- Fixed checking for thinlv provisioning in storage scripts.

* Tue Feb 25 2014 Michal Minar <miminar@redhat.com> 0.2.7-4
- Removed unstable features from hardware scripts.

* Tue Feb 25 2014 Michal Minar <miminar@redhat.com> 0.2.7-3
- Added account and powermanagement commands.

* Tue Feb 25 2014 Michal Minar <miminar@redhat.com> 0.2.7-2
- Fixed storage mount list command.

* Tue Feb 25 2014 Michal Minar <miminar@redhat.com> 0.2.7-1
- Support older OpenLMI Hardware providers.
- Resolves: bz#1069320

* Mon Feb 24 2014 Michal Minar <miminar@redhat.com> 0.2.7-0
- New upstream version.
- Added system library.

* Wed Jan 15 2014 Michal Minar <miminar@redhat.com> 0.2.6-5
- Added networking library.

* Mon Jan 13 2014 Michal Minar <miminar@redhat.com> 0.2.5-4
- New upstream version.

* Mon Nov 11 2013 Michal Minar <miminar@redhat.com> 0.2.4a-3
- Fixed dependency on openlmi-scripts for subpackages.

* Wed Nov 06 2013 Michal Minar <miminar@redhat.com> 0.2.4a-2
- New upstream version.
- Require openlmi-tools 0.9.

* Tue Oct 29 2013 Michal Minar <miminar@redhat.com> 0.2.3-5
- Made the build dependency on openlmi-tools version specific.

* Tue Oct 29 2013 Michal Minar <miminar@redhat.com> 0.2.3-4
- Fixed build, installation problems and rpmlint errors.

* Thu Oct 17 2013 Michal Minar <miminar@redhat.com> 0.2.3-3
- Require python-docopt on build.
- Do not make configs out of completion scripts.
- Removed _isa macros.

* Wed Oct 16 2013 Michal Minar <miminar@redhat.com> 0.2.3-2
- Require openlmi-providers.
- Own config directory.

* Mon Oct 14 2013 Michal Minar <miminar@redhat.com> 0.2.3-1
- Rebased to 0.2.3
- Added bash completion.
- Added documentation.
- Extended installed commands.
- Divided into subpackages.

* Fri Aug 09 2013 Michal Minar <miminar@redhat.com> 0.1.1-1
- Rebased to 0.1.1

* Thu Aug 08 2013 Michal Minar <miminar@redhat.com> 0.1.0-1
- Initial version.

